> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/basic-operations/lock.md).

# Lock a document

Learn about Apryse version 6.0 and its new locking semantics for concurrent access of PDFDoc instances. Develop parallel applications with Apryse SDK efficiently. The Apryse Xamarin SDK streamlines se

As computing devices become more parallel in nature, Apryse is evolving to allow developers to leverage this power in new and exciting ways. Apryse version 6.0 introduces new locking semantics which allow for concurrent access of a [`PDFDoc`](https://sdk.apryse.com/api/xamarinandroid/pdfnet/api/pdftron.PDF.PDFDoc.html) instance. This was done to improve performance during interactive viewing (simultaneous rendering, text extraction, etc.), as well as to open up the possibility for new use cases (parallel rendering). This article introduces the locking system, and will get you on your way to developing parallel applications with Apryse SDK.

## PDFDoc lock

Apryse uses a recursive read/write locking system. Multiple threads can hold a read lock on the document, **but only one thread can hold a write lock at any given time**. A thread can acquire an equivalent or weaker lock as many times as it likes without causing a deadlock. In other words, the following is valid:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc d = new PDFDoc("foo.pdf");
d.Lock();
d.Lock();
d.LockRead();
```

{% endcode %}
{% endtab %}
{% endtabs %}

However, a **thread cannot acquire a write lock while holding a read lock**. Because one can only acquire a write lock when no read locks are held, this situation would inevitably lead to a deadlock. To avoid this scenario, Apryse will throw a runtime exception whenever the situation occurs.

## Apryse API locks

Some of our API calls internally acquire a write lock on the document. As a result, these calls can also throw a runtime exception if they are invoked while holding a read lock. This is noted in each method's documentation. Additionally, you will find a complete list of those methods at the end of this article.

In general, the parts of our library that manage the UI will maintain document locks. **For the lower level calls which actually modify the document, you are responsible for maintaining document locks.**

## Client side locks

Apryse provides the following APIs for locking the document:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
void PDFDoc.Lock();
bool PDFDoc.TryLock(int milliseconds);
void PDFDoc.Unlock();
void PDFDoc.LockRead();
bool PDFDoc.TryLockRead(int milliseconds);
void PDFDoc.UnlockRead();
```

{% endcode %}
{% endtab %}
{% endtabs %}

For convenience, [`PDFViewCtrl`](https://sdk.apryse.com/api/xamarinandroid/pdfnet/api/pdftron.PDF.PDFViewCtrl.html) exposes similar methods, which will be applied to the document currently associated with the control. Additionally, the [`PDFViewCtrl.DocLock`](https://sdk.apryse.com/api/android/javadoc/reference/com/pdftron/pdf/PDFViewCtrl.html#docLock\(boolean\)) method takes a `cancel_rendering` parameter, which will interrupt all worker threads currently accessing the document. This allows you to acquire the write lock as fast as possible:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
void PDFViewCtrl.DocLock(bool cancel_rendering);
bool PDFViewCtrl.DocTryLock(int milliseconds);
void PDFViewCtrl.DocUnlock();
void PDFViewCtrl.DocLockRead();
bool PDFViewCtrl.DocTryLockRead(int milliseconds);
void PDFViewCtrl.DocUnlockRead();
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Filters

At the low level, a `PDFDoc` uses an `input filter` to access its PDF data. this data could be stored on the file system, in a memory buffer, or over a network. Now that Apryse supports concurrent access of `PDFDoc` across many threads; these input filters must also be made thread-safe. StdFile, which was not a thread-safe filter, is no longer available. Instead, you should now use the new [`MappedFile`](https://sdk.apryse.com/api/xamarinandroid/pdfnet/api/pdftron.Filters.MappedFile.html) filter, which provides thread-safe and efficient read access on a file. Custom user filters are still supported, although they are now wrapped in an internal filter that guarantees thread safety.

## Migration of earlier code

The new locking system is backwards compatible, meaning previous calls to [`PDFDoc.Lock`](https://sdk.apryse.com/api/xamarinandroid/pdfnet/api/pdftron.PDF.PDFDoc.html#pdftron_PDF_PDFDoc_Lock) now acquire a write lock. If you would like to take advantage of the ability to read a PDF concurrently, it is your responsibility to review document locks and determine whether it is safe to downgrade them to a read lock.

## Opt out

Conversely, if you are happy with the existing *'one document, one thread'* model previously used in Apryse 5.9., you can continue to work with this system. No change is required on your behalf.

## API calls which can acquire a write lock

### PDFViewCtrl

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
void PDFViewCtrl.CloseDoc();
void PDFViewCtrl.SetDoc(PDFDoc);
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/xamarin/basic-operations/lock.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
